unit trgoogle;

interface
uses
  dvwin,
  dvcrt,
  dvinet,
  winsock,
  sysUtils,
  classes,
  trVars,
  trMsg;

function traduzFraseGoogle (aTraduzir: string; var traduzido: string): string;

implementation
var
    sock: integer;
    pbuf: PbufRede;
    tipoHttp: string;

{-------------------------------------------------------------}

function utfToAnsi (s: string): string;
var b, b2: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    s := s + ' ';
    i := 1;
    while i <= length (s) - 1 do
        begin
            b := ord(s[i]);
            if (b < $80) or ((b and $e0) <> $c0)then
                s2 := s2 + s[i]
            else
                begin
                    b2 := ord (s[i+1]) and $3f;
                    b := (b and $03) shl 6;
                    s2 := s2 + chr(b or b2);
                    i := i + 1;
                end;
            i := i + 1;
        end;
    utfToAnsi := s2;
end;

{-------------------------------------------------------------}

function ansiToUTF (s: string): string;
var b: byte;
    s2: string;
    i: integer;
begin
    s2 := '';
    for i := 1 to length (s) do
        begin
            b := ord(s[i]);
            if b <= $7f then
                s2 := s2 + s[i]
            else
                s2 := s2 + chr ($c0 or ((b shr 6) and $3f)) +
                           chr ($80 or (b and $3f));
        end;
    ansiToUTF := s2;
end;

{-------------------------------------------------------------}

function removeHexas (s: string): string;
var i, n1, n2: integer;
    s2: string;
begin
    s2 := '';
    i := 1;
    while i <= length (s) do
        begin
            if s[i] <> '%' then
                s2 := s2 + s[i]
            else
                begin
                    i := i + 1;
                    n1 := ord(upcase(s[i])) - ord('0');
                    if n1 > 9 then n1 := n1 - 7;

                    i := i + 1;
                    n2 := ord(upcase(s[i])) - ord('0');
                    if n2 > 9 then n2 := n2 - 7;

                    s2 := s2 + chr ((n1 shl 4) + n2);
                end;
            i := i + 1;
        end;
    result := s2;
end;

{-------------------------------------------------------------}

function adicionaHexas (s: string): string;
var i: integer;
    s2: string;
begin
    s2 := '';
    for i := 1 to length(s) do
        begin
            if ord(s[i]) = $20 then
                s2 := s2 + '+'
            else
            if (ord(s[i]) > $20) and (ord(s[i]) < $80) and
               (not (s[i] in ['#', '%', '&', '<', '>', '\']))then
                s2 := s2 + s[i]
            else
                s2 := s2 + '%' + lowerCase (intToHex (ord(s[i]), 2));
        end;
    result := s2;
end;

{-------------------------------------------------------------}

function traduzFraseGoogle (aTraduzir: string; var traduzido: string): string;
var
    s: string;
    i, aReceber: integer;
    c: char;
    p: integer;

begin
    aTraduzir := adicionaHexas(ansiToUtf ('@#@'+aTraduzir));
    traduzido := '';

    s := 'GET /translate_t?hl=&ie=UTF-8&text=' + aTraduzir +
         '&sl=' + linguaOrig + '&tl=' + linguaDest + ' ' +
         'HTTP/1.0';

    s := s + #$0d + #$0a +
             'Host: translate.google.com' + #$0d + #$0a +
             'Accept-Language: pt-br' + #$0d + #$0a +
             'UA-CPU: x86' + #$0d + #$0a +
             'User-Agent: Webvox 3.5' + #$0d + #$0a;

    sock := abreConexao ('translate.google.com', 80);
    if sock <= 0 then
        begin
            mensagem ('TRNOGOOG',2);  {'Google translator est inacessvel.'}
            exit;
        end;
    pbuf := inicBufRede(sock);

    writelnRede (sock, s);

    readlnBufRede (pbuf, s, 10);
    result := s;
    repeat
        if not readlnBufRede (pbuf, s, 10) then s := '';
    until s = '';

    while leCaracBufRede (pbuf, c) do
       traduzido := traduzido + c;

    p := pos ('@ # @', traduzido);
    if p = 0 then
        p := pos ('# @ @', traduzido);
    delete (traduzido, 1, p+5);
    p := pos ('</spa', traduzido);
    delete (traduzido, p, 99999);


    fimBufRede(pbuf);
    closeSocket (sock);
end;

end.
